using System.Collections.Generic;

namespace Checkout
{
    public struct Discount
    {
        public int HowMany;
        public double ForHowMuch;

        public Discount(int howMany, double forHowMuch)
        {
            this.HowMany = howMany;
            this.ForHowMuch = forHowMuch;
        }

        public double DiscountedItemPrice()
        {
            return ForHowMuch/HowMany;
        }
    }

    public class Discounts
    {
        private static Dictionary<string, Discount> discounts;
        public static double GetDiscount(string itemName, int quantity, double itemPrice)
        {
            Discount discount;
            if (discounts.TryGetValue(itemName, out discount))
            {
                var numberOfDiscounts = quantity/discount.HowMany;
                var discountPerSet = discount.HowMany*itemPrice - discount.ForHowMuch;
                return numberOfDiscounts * discountPerSet;
            }
            return 0;
        }

        public static void SetDiscounts(Dictionary<string, Discount> newDiscounts)
        {
            discounts = newDiscounts;
        }
    }
}